#include "lcd.h"
#include "stdlib.h"
#include "font.h"
#include "usart.h"
#include "delay.h"

SRAM_HandleTypeDef TFTSRAM_Handler;    //SRAM(ڿLCD)

//LCDĻɫͱɫ
u16 POINT_COLOR=0x0000; //ɫ
u16 BACK_COLOR=0xFFFF;  //ɫ

//LCDҪ
//ĬΪ
_lcd_dev lcddev;

/**
  * @brief   дĴ
  * @param   regval:Ĵֵ
  * @retval  
  */
void LCD_WR_REG(vu16 regval)
{
    regval=regval;      //ʹ-O2Żʱ,ʱ
    LCD->LCD_REG=regval;//дҪдļĴ
}

/**
  * @brief   дLCD
  * @param   data:Ҫдֵ
  * @retval  
  */
void LCD_WR_DATA(vu16 data)
{
    data=data;          //ʹ-O2Żʱ,ʱ
    LCD->LCD_RAM=data;
}

/**
  * @brief   LCD
  * @param   
  * @retval  ֵ
  */
u16 LCD_RD_DATA(void)
{
    vu16 ram;           //ֹŻ
    ram=LCD->LCD_RAM;
    return ram;
}

/**
  * @brief   дĴ
  * @param   LCD_Reg:Ĵַ
  * @param   LCD_RegValue:Ҫд
  * @retval  
  */
void LCD_WriteReg(u16 LCD_Reg,u16 LCD_RegValue)
{
    LCD->LCD_REG = LCD_Reg;     //дҪдļĴ
    LCD->LCD_RAM = LCD_RegValue;//д
}

/**
  * @brief   Ĵ
  * @param   LCD_Reg:Ĵַ
  * @retval  
  */
u16 LCD_ReadReg(u16 LCD_Reg)
{
    LCD_WR_REG(LCD_Reg);        //дҪļĴ
    delay_us(5);
    return LCD_RD_DATA();       //ضֵ
}

/**
  * @brief   ʼдGRAM
  * @param   
  * @retval  
  */
void LCD_WriteRAM_Prepare(void)
{
    LCD->LCD_REG=lcddev.wramcmd;
}

/**
  * @brief   LCDдGRAM
  * @param   RGB_Code:ɫֵ
  * @retval  
  */
void LCD_WriteRAM(u16 RGB_Code)
{
    LCD->LCD_RAM = RGB_Code;//дʮλGRAM
}
//ILI93xxΪGBRʽдʱΪRGBʽ
//ͨúת
//c:GBRʽɫֵ
//ֵRGBʽɫֵ
u16 LCD_BGR2RGB(u16 c)
{
    u16  r,g,b,rgb;
    b=(c>>0)&0x1f;
    g=(c>>5)&0x3f;
    r=(c>>11)&0x1f;
    rgb=(b<<11)+(g<<5)+(r<<0);
    return(rgb);
}
//mdk -O1ʱŻʱҪ
//ʱi
void opt_delay(u8 i)
{
    while(i--);
}
//ȡĳɫֵ
//x,y:
//ֵ:˵ɫ
u16 LCD_ReadPoint(u16 x,u16 y)
{
    u16 r=0,g=0,b=0;
    if(x>=lcddev.width||y>=lcddev.height)return 0;  //˷Χ,ֱӷ
    LCD_SetCursor(x,y);
    if(lcddev.id==0X9341||lcddev.id==0X6804||lcddev.id==0X5310||lcddev.id==0X1963)LCD_WR_REG(0X2E);//9341/6804/3510/1963 ͶGRAMָ
    else if(lcddev.id==0X5510)LCD_WR_REG(0X2E00);   //5510 ͶGRAMָ
    else LCD_WR_REG(0X22);                          //ICͶGRAMָ
    if(lcddev.id==0X9320)opt_delay(2);              //FOR 9320,ʱ2us
    r=LCD_RD_DATA();                                //dummy Read
    if(lcddev.id==0X1963)return r;                  //1963ֱӶͿ
    opt_delay(2);
    r=LCD_RD_DATA();                                //ʵɫ
    if(lcddev.id==0X9341||lcddev.id==0X5310||lcddev.id==0X5510)     //9341/NT35310/NT35510Ҫ2ζ
    {
        opt_delay(2);
        b=LCD_RD_DATA();
        g=r&0XFF;       //9341/5310/5510,һζȡRGֵ,Rǰ,Gں,ռ8λ
        g<<=8;
    }
    if(lcddev.id==0X9325||lcddev.id==0X4535||lcddev.id==0X4531||lcddev.id==0XB505||lcddev.id==0XC505)return r;  //⼸ICֱӷɫֵ
    else if(lcddev.id==0X9341||lcddev.id==0X5310||lcddev.id==0X5510)return (((r>>11)<<11)|((g>>10)<<5)|(b>>11));//ILI9341/NT35310/NT35510Ҫʽתһ
    else return LCD_BGR2RGB(r);                     //IC
}
//LCDʾ
void LCD_DisplayOn(void)
{
    if(lcddev.id==0X9341||lcddev.id==0X6804||lcddev.id==0X5310||lcddev.id==0X1963)LCD_WR_REG(0X29); //ʾ
    else if(lcddev.id==0X5510)LCD_WR_REG(0X2900);   //ʾ
    else LCD_WriteReg(0X07,0x0173);                     //ʾ
}
//LCDرʾ
void LCD_DisplayOff(void)
{
    if(lcddev.id==0X9341||lcddev.id==0X6804||lcddev.id==0X5310||lcddev.id==0X1963)LCD_WR_REG(0X28); //رʾ
    else if(lcddev.id==0X5510)LCD_WR_REG(0X2800);   //رʾ
    else LCD_WriteReg(0X07,0x0);//رʾ
}
//ùλ
//Xpos:
//Ypos:
void LCD_SetCursor(u16 Xpos, u16 Ypos)
{
    if(lcddev.id==0X9341||lcddev.id==0X5310)
    {
        LCD_WR_REG(lcddev.setxcmd);
        LCD_WR_DATA(Xpos>>8);LCD_WR_DATA(Xpos&0XFF);
        LCD_WR_REG(lcddev.setycmd);
        LCD_WR_DATA(Ypos>>8);LCD_WR_DATA(Ypos&0XFF);
    }else if(lcddev.id==0X6804)
    {
        if(lcddev.dir==1)Xpos=lcddev.width-1-Xpos;//ʱ
        LCD_WR_REG(lcddev.setxcmd);
        LCD_WR_DATA(Xpos>>8);LCD_WR_DATA(Xpos&0XFF);
        LCD_WR_REG(lcddev.setycmd);
        LCD_WR_DATA(Ypos>>8);LCD_WR_DATA(Ypos&0XFF);
    }else if(lcddev.id==0X1963)
    {
        if(lcddev.dir==0)//xҪ任
        {
            Xpos=lcddev.width-1-Xpos;
            LCD_WR_REG(lcddev.setxcmd);
            LCD_WR_DATA(0);LCD_WR_DATA(0);
            LCD_WR_DATA(Xpos>>8);LCD_WR_DATA(Xpos&0XFF);
        }else
        {
            LCD_WR_REG(lcddev.setxcmd);
            LCD_WR_DATA(Xpos>>8);LCD_WR_DATA(Xpos&0XFF);
            LCD_WR_DATA((lcddev.width-1)>>8);LCD_WR_DATA((lcddev.width-1)&0XFF);
        }
        LCD_WR_REG(lcddev.setycmd);
        LCD_WR_DATA(Ypos>>8);LCD_WR_DATA(Ypos&0XFF);
        LCD_WR_DATA((lcddev.height-1)>>8);LCD_WR_DATA((lcddev.height-1)&0XFF);

    }else if(lcddev.id==0X5510)
    {
        LCD_WR_REG(lcddev.setxcmd);LCD_WR_DATA(Xpos>>8);
        LCD_WR_REG(lcddev.setxcmd+1);LCD_WR_DATA(Xpos&0XFF);
        LCD_WR_REG(lcddev.setycmd);LCD_WR_DATA(Ypos>>8);
        LCD_WR_REG(lcddev.setycmd+1);LCD_WR_DATA(Ypos&0XFF);
    }else
    {
        if(lcddev.dir==1)Xpos=lcddev.width-1-Xpos;//ʵǵתx,y
        LCD_WriteReg(lcddev.setxcmd, Xpos);
        LCD_WriteReg(lcddev.setycmd, Ypos);
    }
}
//LCDԶɨ跽
//ע:ܻܵ˺õӰ(9341/6804),
//,һΪL2R_U2D,Ϊɨ跽ʽ,ܵʾ.
//dir:0~7,8(嶨lcd.h)
//9320/9325/9328/4531/4535/1505/b505/5408/9341/5310/5510/1963ICѾʵʲ
void LCD_Scan_Dir(u8 dir)
{
    u16 regval=0;
    u16 dirreg=0;
        switch(dir)
        {
            case L2R_U2D://,ϵ
                regval|=(1<<5)|(1<<4)|(0<<3);
                break;
            case L2R_D2U://,µ
                regval|=(0<<5)|(1<<4)|(0<<3);
                break;
            case R2L_U2D://ҵ,ϵ
                regval|=(1<<5)|(0<<4)|(0<<3);
                break;
            case R2L_D2U://ҵ,µ
                regval|=(0<<5)|(0<<4)|(0<<3);
                break;
            case U2D_L2R://ϵ,
                regval|=(1<<5)|(1<<4)|(1<<3);
                break;
            case U2D_R2L://ϵ,ҵ
                regval|=(1<<5)|(0<<4)|(1<<3);
                break;
            case D2U_L2R://µ,
                regval|=(0<<5)|(1<<4)|(1<<3);
                break;
            case D2U_R2L://µ,ҵ
                regval|=(0<<5)|(0<<4)|(1<<3);
                break;
        }
        dirreg=0X03;
        regval|=1<<12;
        LCD_WriteReg(dirreg,regval);
}
//
//x,y:
//POINT_COLOR:˵ɫ
void LCD_DrawPoint(u16 x,u16 y)
{
    LCD_SetCursor(x,y);     //ùλ
    LCD_WriteRAM_Prepare(); //ʼдGRAM
    LCD->LCD_RAM=POINT_COLOR;
}
//ٻ
//x,y:
//color:ɫ
void LCD_Fast_DrawPoint(u16 x,u16 y,u16 color)
{
    if(lcddev.id==0X9341||lcddev.id==0X5310)
    {
        LCD_WR_REG(lcddev.setxcmd);
        LCD_WR_DATA(x>>8);LCD_WR_DATA(x&0XFF);
        LCD_WR_REG(lcddev.setycmd);
        LCD_WR_DATA(y>>8);LCD_WR_DATA(y&0XFF);
    }else if(lcddev.id==0X5510)
    {
        LCD_WR_REG(lcddev.setxcmd);LCD_WR_DATA(x>>8);
        LCD_WR_REG(lcddev.setxcmd+1);LCD_WR_DATA(x&0XFF);
        LCD_WR_REG(lcddev.setycmd);LCD_WR_DATA(y>>8);
        LCD_WR_REG(lcddev.setycmd+1);LCD_WR_DATA(y&0XFF);
    }else if(lcddev.id==0X1963)
    {
        if(lcddev.dir==0)x=lcddev.width-1-x;
        LCD_WR_REG(lcddev.setxcmd);
        LCD_WR_DATA(x>>8);LCD_WR_DATA(x&0XFF);
        LCD_WR_DATA(x>>8);LCD_WR_DATA(x&0XFF);
        LCD_WR_REG(lcddev.setycmd);
        LCD_WR_DATA(y>>8);LCD_WR_DATA(y&0XFF);
        LCD_WR_DATA(y>>8);LCD_WR_DATA(y&0XFF);
    }else if(lcddev.id==0X6804)
    {
        if(lcddev.dir==1)x=lcddev.width-1-x;//ʱ
        LCD_WR_REG(lcddev.setxcmd);
        LCD_WR_DATA(x>>8);LCD_WR_DATA(x&0XFF);
        LCD_WR_REG(lcddev.setycmd);
        LCD_WR_DATA(y>>8);LCD_WR_DATA(y&0XFF);
    }else
    {
        if(lcddev.dir==1)x=lcddev.width-1-x;//ʵǵתx,y
        LCD_WriteReg(lcddev.setxcmd,x);
        LCD_WriteReg(lcddev.setycmd,y);
    }
    LCD->LCD_REG=lcddev.wramcmd;
    LCD->LCD_RAM=color;
}
//SSD1963 
//pwm:ȼ,0~100.ԽԽ.
void LCD_SSD_BackLightSet(u8 pwm)
{
    LCD_WR_REG(0xBE);   //PWM
    LCD_WR_DATA(0x05);  //1PWMƵ
    LCD_WR_DATA(pwm*2.55);//2PWMռձ
    LCD_WR_DATA(0x01);  //3C
    LCD_WR_DATA(0xFF);  //4D
    LCD_WR_DATA(0x00);  //5E
    LCD_WR_DATA(0x00);  //6F
}

//LCDʾ
//dir:0,1,
void LCD_Display_Dir(u8 dir)
{
    if(dir==0)          //
    {
        lcddev.dir=0;   //
        lcddev.width=240;
        lcddev.height=320;
            lcddev.wramcmd=0X22;
            lcddev.setxcmd=0X20;
            lcddev.setycmd=0X21;
    }else               //
    {
        lcddev.dir=1;   //
        lcddev.width=320;
        lcddev.height=240;
            lcddev.wramcmd=0X22;
            lcddev.setxcmd=0X21;
            lcddev.setycmd=0X20;
    }
    LCD_Scan_Dir(DFT_SCAN_DIR); //Ĭɨ跽
}
//ô,Զû굽Ͻ(sx,sy).
//sx,sy:ʼ(Ͻ)
//width,height:ڿȺ͸߶,0!!
//С:width*height.
void LCD_Set_Window(u16 sx,u16 sy,u16 width,u16 height)
{
    u8 hsareg,heareg,vsareg,veareg;
    u16 hsaval,heaval,vsaval,veaval;
    u16 twidth,theight;
    twidth=sx+width-1;
    theight=sy+height-1;
    if(lcddev.id==0X9341||lcddev.id==0X5310||lcddev.id==0X6804||(lcddev.dir==1&&lcddev.id==0X1963))
    {
        LCD_WR_REG(lcddev.setxcmd);
        LCD_WR_DATA(sx>>8);
        LCD_WR_DATA(sx&0XFF);
        LCD_WR_DATA(twidth>>8);
        LCD_WR_DATA(twidth&0XFF);
        LCD_WR_REG(lcddev.setycmd);
        LCD_WR_DATA(sy>>8);
        LCD_WR_DATA(sy&0XFF);
        LCD_WR_DATA(theight>>8);
        LCD_WR_DATA(theight&0XFF);
    }else if(lcddev.id==0X1963)//1963⴦
    {
        sx=lcddev.width-width-sx;
        height=sy+height-1;
        LCD_WR_REG(lcddev.setxcmd);
        LCD_WR_DATA(sx>>8);
        LCD_WR_DATA(sx&0XFF);
        LCD_WR_DATA((sx+width-1)>>8);
        LCD_WR_DATA((sx+width-1)&0XFF);
        LCD_WR_REG(lcddev.setycmd);
        LCD_WR_DATA(sy>>8);
        LCD_WR_DATA(sy&0XFF);
        LCD_WR_DATA(height>>8);
        LCD_WR_DATA(height&0XFF);
    }else if(lcddev.id==0X5510)
    {
        LCD_WR_REG(lcddev.setxcmd);LCD_WR_DATA(sx>>8);
        LCD_WR_REG(lcddev.setxcmd+1);LCD_WR_DATA(sx&0XFF);
        LCD_WR_REG(lcddev.setxcmd+2);LCD_WR_DATA(twidth>>8);
        LCD_WR_REG(lcddev.setxcmd+3);LCD_WR_DATA(twidth&0XFF);
        LCD_WR_REG(lcddev.setycmd);LCD_WR_DATA(sy>>8);
        LCD_WR_REG(lcddev.setycmd+1);LCD_WR_DATA(sy&0XFF);
        LCD_WR_REG(lcddev.setycmd+2);LCD_WR_DATA(theight>>8);
        LCD_WR_REG(lcddev.setycmd+3);LCD_WR_DATA(theight&0XFF);
    }else   //IC
    {
        if(lcddev.dir==1)//
        {
            //ֵ
            hsaval=sy;
            heaval=theight;
            vsaval=lcddev.width-twidth-1;
            veaval=lcddev.width-sx-1;
        }else
        {
            hsaval=sx;
            heaval=twidth;
            vsaval=sy;
            veaval=theight;
        }
        hsareg=0X50;heareg=0X51;//ˮƽ򴰿ڼĴ
        vsareg=0X52;veareg=0X53;//ֱ򴰿ڼĴ
        //üĴֵ
        LCD_WriteReg(hsareg,hsaval);
        LCD_WriteReg(heareg,heaval);
        LCD_WriteReg(vsareg,vsaval);
        LCD_WriteReg(veareg,veaval);
        LCD_SetCursor(sx,sy);   //ùλ
    }
}
//ʼlcd
//óʼԳʼILI93XXҺ,ǻILI9320!!!
//ͺŵоƬûв!
void LCD_Init(void)
{
    vu32 i=0;

    GPIO_InitTypeDef GPIO_Initure;
    FSMC_NORSRAM_TimingTypeDef FSMC_ReadWriteTim;
    FSMC_NORSRAM_TimingTypeDef FSMC_WriteTim;

    __HAL_RCC_FSMC_CLK_ENABLE();            //ʹFSMCʱ
    __HAL_RCC_GPIOD_CLK_ENABLE();           //ʹGPIODʱ
    __HAL_RCC_GPIOE_CLK_ENABLE();           //ʹGPIOEʱ
    __HAL_RCC_GPIOF_CLK_ENABLE();           //ʹGPIOFʱ
    __HAL_RCC_GPIOG_CLK_ENABLE();           //ʹGPIOGʱ

    //ʼ
    GPIO_Initure.Pin = GPIO_PIN_11;
    GPIO_Initure.Mode=GPIO_MODE_OUTPUT_PP;      //
    GPIO_Initure.Pull=GPIO_PULLUP;          //
    GPIO_Initure.Speed=GPIO_SPEED_HIGH;     //
    HAL_GPIO_Init(GPIOF,&GPIO_Initure);     //ʼ

    //ʼPD0,1,4,5,8,9,10,14,15
    GPIO_Initure.Pin=GPIO_PIN_0|GPIO_PIN_1|GPIO_PIN_4|GPIO_PIN_5|GPIO_PIN_8|\
                     GPIO_PIN_9|GPIO_PIN_10|GPIO_PIN_14|GPIO_PIN_15;
    GPIO_Initure.Mode=GPIO_MODE_AF_PP;      //츴
    GPIO_Initure.Pull=GPIO_PULLUP;          //
    GPIO_Initure.Speed=GPIO_SPEED_HIGH;     //
    GPIO_Initure.Alternate=GPIO_AF12_FSMC;  //ΪFSMC
    HAL_GPIO_Init(GPIOD,&GPIO_Initure);     //ʼ

    //ʼPE7,8,9,10,11,12,13,14,15
    GPIO_Initure.Pin=GPIO_PIN_7|GPIO_PIN_8|GPIO_PIN_9|GPIO_PIN_10|GPIO_PIN_11|\
                     GPIO_PIN_12|GPIO_PIN_13|GPIO_PIN_14|GPIO_PIN_15;
    HAL_GPIO_Init(GPIOE,&GPIO_Initure);

    //ʼPF12
    GPIO_Initure.Pin=GPIO_PIN_12;
    HAL_GPIO_Init(GPIOF,&GPIO_Initure);

    //ʼPG12
    GPIO_Initure.Pin=GPIO_PIN_12;
    HAL_GPIO_Init(GPIOG,&GPIO_Initure);

    TFTSRAM_Handler.Instance=FSMC_NORSRAM_DEVICE;
    TFTSRAM_Handler.Extended=FSMC_NORSRAM_EXTENDED_DEVICE;

    TFTSRAM_Handler.Init.NSBank=FSMC_NORSRAM_BANK4;                     //ʹNE4
    TFTSRAM_Handler.Init.DataAddressMux=FSMC_DATA_ADDRESS_MUX_DISABLE;  //ַ/߲
    TFTSRAM_Handler.Init.MemoryType=FSMC_MEMORY_TYPE_SRAM;              //SRAM
    TFTSRAM_Handler.Init.MemoryDataWidth=FSMC_NORSRAM_MEM_BUS_WIDTH_16; //16λݿ
    TFTSRAM_Handler.Init.BurstAccessMode=FSMC_BURST_ACCESS_MODE_DISABLE; //Ƿʹͻ,ͬͻ洢Ч,˴δõ
    TFTSRAM_Handler.Init.WaitSignalPolarity=FSMC_WAIT_SIGNAL_POLARITY_LOW;//ȴźŵļ,ͻģʽ
    TFTSRAM_Handler.Init.WaitSignalActive=FSMC_WAIT_TIMING_BEFORE_WS;   //洢ڵȴ֮ǰһʱڻǵȴڼʹNWAIT
    TFTSRAM_Handler.Init.WriteOperation=FSMC_WRITE_OPERATION_ENABLE;    //洢дʹ
    TFTSRAM_Handler.Init.WaitSignal=FSMC_WAIT_SIGNAL_DISABLE;           //ȴʹλ,˴δõ
    TFTSRAM_Handler.Init.ExtendedMode=FSMC_EXTENDED_MODE_ENABLE;        //дʹòͬʱ
    TFTSRAM_Handler.Init.AsynchronousWait=FSMC_ASYNCHRONOUS_WAIT_DISABLE;//Ƿʹͬģʽµĵȴź,˴δõ
    TFTSRAM_Handler.Init.WriteBurst=FSMC_WRITE_BURST_DISABLE;           //ֹͻд
    TFTSRAM_Handler.Init.ContinuousClock=FSMC_CONTINUOUS_CLOCK_SYNC_ASYNC;

    //FMCʱƼĴ
    FSMC_ReadWriteTim.AddressSetupTime=0x0F;        //ַʱ䣨ADDSETΪ16HCLK 1/168M=6ns*16=96ns
    FSMC_ReadWriteTim.AddressHoldTime=0;
    FSMC_ReadWriteTim.DataSetupTime=60;             //ݱʱΪ60HCLK    =6*60=360ns
    FSMC_ReadWriteTim.AccessMode=FSMC_ACCESS_MODE_A;//ģʽA
    //FMCдʱƼĴ
    FSMC_WriteTim.BusTurnAroundDuration=0;          //ת׶γʱΪ0˱ֵĻĪԶ޸Ϊ4³
    FSMC_WriteTim.AddressSetupTime=9;               //ַʱ䣨ADDSETΪ9HCLK =54ns
    FSMC_WriteTim.AddressHoldTime=0;
    FSMC_WriteTim.DataSetupTime=8;                  //ݱʱΪ6ns*9HCLK=54n
    FSMC_WriteTim.AccessMode=FSMC_ACCESS_MODE_A;    //ģʽA
    HAL_SRAM_Init(&TFTSRAM_Handler,&FSMC_ReadWriteTim,&FSMC_WriteTim);


    delay_ms(50); // delay 50 ms
    LCD_WriteReg(0x0000,0x0001);
    delay_ms(50); // delay 50 ms
    lcddev.id = LCD_ReadReg(0x0000);
    printf(" LCD ID:%x\r\n",lcddev.id); //ӡLCD ID
		if(lcddev.id==0x9320)//OK.
    {
//			void LCD_WriteReg(u16 LCD_Reg,u16 LCD_RegValue)
//{
//      	LCD->LCD_REG = LCD_Reg;     //дҪдļĴ
//      	LCD->LCD_RAM = LCD_RegValue;//д
//}
        LCD_WriteReg(0x00,0x0000);
        LCD_WriteReg(0x01,0x0100);  //Driver Output Contral.
        LCD_WriteReg(0x02,0x0700);  //LCD Driver Waveform Contral.
        LCD_WriteReg(0x03,0x1030);//Entry Mode Set.
        //LCD_WriteReg(0x03,0x1018);    //Entry Mode Set.

        LCD_WriteReg(0x04,0x0000);  //Scalling Contral.
        LCD_WriteReg(0x08,0x0202);  //Display Contral 2.(0x0207)
        LCD_WriteReg(0x09,0x0000);  //Display Contral 3.(0x0000)
        LCD_WriteReg(0x0a,0x0000);  //Frame Cycle Contal.(0x0000)
        LCD_WriteReg(0x0c,(1<<0));  //Extern Display Interface Contral 1.(0x0000)
        LCD_WriteReg(0x0d,0x0000);  //Frame Maker Position.
        LCD_WriteReg(0x0f,0x0000);  //Extern Display Interface Contral 2.
        delay_ms(50);
        LCD_WriteReg(0x07,0x0101);  //Display Contral.
        delay_ms(50);
        LCD_WriteReg(0x10,(1<<12)|(0<<8)|(1<<7)|(1<<6)|(0<<4)); //Power Control 1.(0x16b0)
        LCD_WriteReg(0x11,0x0007);                              //Power Control 2.(0x0001)
        LCD_WriteReg(0x12,(1<<8)|(1<<4)|(0<<0));                //Power Control 3.(0x0138)
        LCD_WriteReg(0x13,0x0b00);                              //Power Control 4.
        LCD_WriteReg(0x29,0x0000);                              //Power Control 7.

        LCD_WriteReg(0x2b,(1<<14)|(1<<4));
        LCD_WriteReg(0x50,0);   //Set X Star
        //ˮƽGRAMֹλSet X End.
        LCD_WriteReg(0x51,239); //Set Y Star
        LCD_WriteReg(0x52,0);   //Set Y End.t.
        LCD_WriteReg(0x53,319); //

        LCD_WriteReg(0x60,0x2700);  //Driver Output Control.
        LCD_WriteReg(0x61,0x0001);  //Driver Output Control.
        LCD_WriteReg(0x6a,0x0000);  //Vertical Srcoll Control.

        LCD_WriteReg(0x80,0x0000);  //Display Position? Partial Display 1.
        LCD_WriteReg(0x81,0x0000);  //RAM Address Start? Partial Display 1.
        LCD_WriteReg(0x82,0x0000);  //RAM Address End-Partial Display 1.
        LCD_WriteReg(0x83,0x0000);  //Displsy Position? Partial Display 2.
        LCD_WriteReg(0x84,0x0000);  //RAM Address Start? Partial Display 2.
        LCD_WriteReg(0x85,0x0000);  //RAM Address End? Partial Display 2.

        LCD_WriteReg(0x90,(0<<7)|(16<<0));  //Frame Cycle Contral.(0x0013)
        LCD_WriteReg(0x92,0x0000);  //Panel Interface Contral 2.(0x0000)
        LCD_WriteReg(0x93,0x0001);  //Panel Interface Contral 3.
        LCD_WriteReg(0x95,0x0110);  //Frame Cycle Contral.(0x0110)
        LCD_WriteReg(0x97,(0<<8));  //
        LCD_WriteReg(0x98,0x0000);  //Frame Cycle Contral.
        LCD_WriteReg(0x07,0x0173);  //(0x0173)
    }
    LCD_Display_Dir(0);     //ĬΪ
    LCD_LED=0;              //
    LCD_Clear(WHITE);
}
//
//color:Ҫɫ
void LCD_Clear(u16 color)
{
    u32 index=0;
    u32 totalpoint=lcddev.width;
    totalpoint*=lcddev.height;          //õܵ
    LCD_SetCursor(0x00,0x0000);   //ùλ
    LCD_WriteRAM_Prepare();             //ʼдGRAM
    for(index=0;index<totalpoint;index++)
    {
        LCD->LCD_RAM=color;
    }
}
//ָ䵥ɫ
//(sx,sy),(ex,ey):ζԽ,СΪ:(ex-sx+1)*(ey-sy+1)
//color:Ҫɫ
void LCD_Fill(u16 sx,u16 sy,u16 ex,u16 ey,u16 color)
{
    u16 i,j;
    u16 xlen=0;
    u16 temp;
    if((lcddev.id==0X6804)&&(lcddev.dir==1))    //6804ʱ⴦
    {
        temp=sx;
        sx=sy;
        sy=lcddev.width-ex-1;
        ex=ey;
        ey=lcddev.width-temp-1;
        lcddev.dir=0;
        lcddev.setxcmd=0X2A;
        lcddev.setycmd=0X2B;
        LCD_Fill(sx,sy,ex,ey,color);
        lcddev.dir=1;
        lcddev.setxcmd=0X2B;
        lcddev.setycmd=0X2A;
    }else
    {
        xlen=ex-sx+1;
        for(i=sy;i<=ey;i++)
        {
            LCD_SetCursor(sx,i);                    //ùλ
            LCD_WriteRAM_Prepare();                 //ʼдGRAM
            for(j=0;j<xlen;j++)LCD->LCD_RAM=color;  //ʾɫ
        }
    }
}
//ָָɫ
//(sx,sy),(ex,ey):ζԽ,СΪ:(ex-sx+1)*(ey-sy+1)
//color:Ҫɫ
void LCD_Color_Fill(u16 sx,u16 sy,u16 ex,u16 ey,u16 *color)
{
    u16 height,width;
    u16 i,j;
    width=ex-sx+1;          //õĿ
    height=ey-sy+1;         //߶
    for(i=0;i<height;i++)
    {
        LCD_SetCursor(sx,sy+i);     //ùλ
        LCD_WriteRAM_Prepare();     //ʼдGRAM
        for(j=0;j<width;j++)LCD->LCD_RAM=color[i*width+j];//д
    }
}
//
//x1,y1:
//x2,y2:յ
void LCD_DrawLine(u16 x1, u16 y1, u16 x2, u16 y2)
{
    u16 t;
    int xerr=0,yerr=0,delta_x,delta_y,distance;
    int incx,incy,uRow,uCol;
    delta_x=x2-x1; //
    delta_y=y2-y1;
    uRow=x1;
    uCol=y1;
    if(delta_x>0)incx=1; //õ
    else if(delta_x==0)incx=0;//ֱ
    else {incx=-1;delta_x=-delta_x;}
    if(delta_y>0)incy=1;
    else if(delta_y==0)incy=0;//ˮƽ
    else{incy=-1;delta_y=-delta_y;}
    if( delta_x>delta_y)distance=delta_x; //ѡȡ
    else distance=delta_y;
    for(t=0;t<=distance+1;t++ )//
    {
        LCD_DrawPoint(uRow,uCol);//
        xerr+=delta_x ;
        yerr+=delta_y ;
        if(xerr>distance)
        {
            xerr-=distance;
            uRow+=incx;
        }
        if(yerr>distance)
        {
            yerr-=distance;
            uCol+=incy;
        }
    }
}
//
//(x1,y1),(x2,y2):εĶԽ
void LCD_DrawRectangle(u16 x1, u16 y1, u16 x2, u16 y2)
{
    LCD_DrawLine(x1,y1,x2,y1);
    LCD_DrawLine(x1,y1,x1,y2);
    LCD_DrawLine(x1,y2,x2,y2);
    LCD_DrawLine(x2,y1,x2,y2);
}
//ָλûһָСԲ
//(x,y):ĵ
//r    :뾶
void LCD_Draw_Circle(u16 x0,u16 y0,u8 r)
{
    int a,b;
    int di;
    a=0;b=r;
    di=3-(r<<1);             //ж¸λõı־
    while(a<=b)
    {
        LCD_DrawPoint(x0+a,y0-b);             //5
        LCD_DrawPoint(x0+b,y0-a);             //0
        LCD_DrawPoint(x0+b,y0+a);             //4
        LCD_DrawPoint(x0+a,y0+b);             //6
        LCD_DrawPoint(x0-a,y0+b);             //1
        LCD_DrawPoint(x0-b,y0+a);
        LCD_DrawPoint(x0-a,y0-b);             //2
        LCD_DrawPoint(x0-b,y0-a);             //7
        a++;
        //ʹBresenham㷨Բ
        if(di<0)di +=4*a+6;
        else
        {
            di+=10+4*(a-b);
            b--;
        }
    }
}
//ָλʾһַ
//x,y:ʼ
//num:Ҫʾַ:" "--->"~"
//size:С 12/16/24
//mode:ӷʽ(1)Ƿǵӷʽ(0)
void LCD_ShowChar(u16 x,u16 y,u8 num,u8 size,u8 mode)
{
    u8 temp,t1,t;
    u16 y0=y;
    u8 csize=(size/8+((size%8)?1:0))*(size/2);      //õһַӦռֽ
    num=num-' ';//õƫƺֵASCIIֿǴӿոʼȡģ-' 'ǶӦַֿ⣩
    for(t=0;t<csize;t++)
    {
        if(size==12)temp=asc2_1206[num][t];         //1206
        else if(size==16)temp=asc2_1608[num][t];    //1608
        else if(size==24)temp=asc2_2412[num][t];    //2412
        else return;                                //ûеֿ
        for(t1=0;t1<8;t1++)
        {
            if(temp&0x80)LCD_Fast_DrawPoint(x,y,POINT_COLOR);
            else if(mode==0)LCD_Fast_DrawPoint(x,y,BACK_COLOR);
            temp<<=1;
            y++;
            if(y>=lcddev.height)return;     //
            if((y-y0)==size)
            {
                y=y0;
                x++;
                if(x>=lcddev.width)return;  //
                break;
            }
        }
    }
}
//m^n
//ֵ:m^nη.
u32 LCD_Pow(u8 m,u8 n)
{
    u32 result=1;
    while(n--)result*=m;
    return result;
}
//ʾ,λΪ0,ʾ
//x,y :
//len :ֵλ
//size:С
//color:ɫ
//num:ֵ(0~4294967295);
void LCD_ShowNum(u16 x,u16 y,u32 num,u8 len,u8 size)
{
    u8 t,temp;
    u8 enshow=0;
    for(t=0;t<len;t++)
    {
        temp=(num/LCD_Pow(10,len-t-1))%10;
        if(enshow==0&&t<(len-1))
        {
            if(temp==0)
            {
                LCD_ShowChar(x+(size/2)*t,y,' ',size,0);
                continue;
            }else enshow=1;

        }
        LCD_ShowChar(x+(size/2)*t,y,temp+'0',size,0);
    }
}
//ʾ,λΪ0,ʾ
//x,y:
//num:ֵ(0~999999999);
//len:(Ҫʾλ)
//size:С
//mode:
//[7]:0,;1,0.
//[6:1]:
//[0]:0,ǵʾ;1,ʾ.
void LCD_ShowxNum(u16 x,u16 y,u32 num,u8 len,u8 size,u8 mode)
{
    u8 t,temp;
    u8 enshow=0;
    for(t=0;t<len;t++)
    {
        temp=(num/LCD_Pow(10,len-t-1))%10;
        if(enshow==0&&t<(len-1))
        {
            if(temp==0)
            {
                if(mode&0X80)LCD_ShowChar(x+(size/2)*t,y,'0',size,mode&0X01);
                else LCD_ShowChar(x+(size/2)*t,y,' ',size,mode&0X01);
                continue;
            }else enshow=1;

        }
        LCD_ShowChar(x+(size/2)*t,y,temp+'0',size,mode&0X01);
    }
}
//ʾַ
//x,y:
//width,height:С
//size:С
//*p:ַʼַ
void LCD_ShowString(u16 x,u16 y,u16 width,u16 height,u8 size,u8 *p)
{
    u8 x0=x;
    width+=x;
    height+=y;
    while((*p<='~')&&(*p>=' '))//жǲǷǷַ!
    {
        if(x>=width){x=x0;y+=size;}
        if(y>=height)break;//˳
        LCD_ShowChar(x,y,*p,size,0);
        x+=size/2;
        p++;
    }
}



























